<template lang="pug">
Box(:title="$t('page.profile.stat.my.title')")
  .columns.is-flex.is-multiline
    .column.is-6-widescreen.is-12-tablet.is-12-mobile(
      v-for="({ text, value }, i) in stat",
      :key="i"
    )
      stat-item(:text="text", :value="value")
</template>

<script lang="ts">
import Vue from "vue";
import Component from "vue-class-component";
import { VModel, Prop, Watch } from "vue-property-decorator";
import { BigNumber } from "bignumber.js";
import { UserModule } from "./../../store/module/UserModule";
import { PoolModule } from "../../store/module/PoolModule";
import { NumberFormat } from "./../../helpers/NumberFormat"
import Web3 from "web3";

export type StatItem = {
  text: any;
  value: string;
};

@Component({
  components: {
    Box: () => import("../Box.vue"),
    StatItem: () => import("./StatItem.vue"),
  },
})
export default class Stat extends Vue {
  stat: StatItem[] = [
    {
      text: this.$t("page.profile.stat.my.total_staked"),
      value: "0",
    },
    {
      text: this.$t("page.profile.stat.my.total_generated"),
      value: "0",
    },
  ];

  get account() {
    return this.$store.getters["Web3Module/account"];
  }

  get user(): UserModule.User {
    return this.$store.getters["UserModule/user"];
  }

  get memePool(): PoolModule.Pool {
    return this.$store.getters["PoolModule/memePool"];
  }

  @Watch("user")
  onUserChange() {
    this.load();
  }

  @Watch("memePool")
  onPoolChange() {
    this.load();
  }

  async load() {
    if (!this.user?.address) return;
    if (this.memePool.id === 0) return;

    let totalStaked = new BigNumber(0)
    let totalClaimed = new BigNumber(0)

    this.user?.stakes
      ?.filter((stake) => stake.poolId === this.memePool.id)
      .sort((a, b) => {
        return (
          new Date(a.createdAt).getTime() - new Date(b.createdAt).getTime()
        );
      })
      .map((stake) => {
        totalStaked = totalStaked.plus(new BigNumber(stake.body))
        stake!.claims!.map((claim) => {
          totalClaimed = totalClaimed.plus(new BigNumber(claim.amount))
        });
      });

    this.stat[0].value = NumberFormat.format(totalStaked.dividedBy(10 ** 18))
    this.stat[1].value = NumberFormat.format(totalClaimed.dividedBy(10 ** 18))
  }

  async mounted() {
    this.load();
  }
}
</script>